Index: trunk/NEMO/OPA_SRC/SOL/solpcg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 16)
@@ -14,4 +14,5 @@
    USE lib_mpp         ! distributed memory computing
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
@@ -32,6 +33,6 @@
       !!                    
       !! ** Purpose :   Solve the ellipic equation for the barotropic stream 
-      !!      function system (default option) or the transport divergence 
-      !!      system ("key_dynspg_fsc") using a diagonal preconditionned
+      !!      function system (lk_dynspg_rl=T) or the transport divergence 
+      !!      system (lk_dynspg_fsc=T) using a diagonal preconditionned
       !!      conjugate gradient method.
       !!      In the former case, the barotropic stream function trend has a
@@ -93,42 +94,17 @@
          !                                             !================
 
-         !,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-         
-         IF( jn == 1 ) THEN
-            
-            ! 1.0 Initialization of the algorithm
-            ! -----------------------------------
-            
-#if defined key_dynspg_fsc
-#   if defined key_mpp
-            ! Mpp: export boundary values to neighbouring processors
-            CALL lbc_lnk( gcx, 'S', 1. )
-#   else
-            !   mono- or macro-tasking: W-point, >0, 2D array, no slab
-            CALL lbc_lnk( gcx, 'T', 1. )
-#   endif
-#else
-#   if defined key_mpp
-            ! ... Mpp: export boundary values to neighbouring processors
-            CALL lbc_lnk( gcx, 'G', 1. )
-#   else
-            !   ... mono- or macro-tasking: F-point, >0, 2D array, no slab
-            CALL lbc_lnk( gcx, 'F', 1. )
-#   endif
-#endif
+         IF( jn == 1 ) THEN           ! Initialization of the algorithm
 
-            !,,,,,,,,,,,,,,,,,,,,,,,,synchro ,,,,,,,,,,,,,,,,,,,,,,,
-            
+            CALL lbc_lnk( gcx, c_solver_pt, 1. )   ! lateral boundary condition
+
             ! gcr   = gcb-a.gcx
             ! gcdes = gsr
-            
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zgcad = bmask(ji,jj)*(                         &
-                    gcb(ji,jj  ) -              gcx(ji  ,jj  )   &
-                                 - gcp(ji,jj,1)*gcx(ji  ,jj-1)   &
-                                 - gcp(ji,jj,2)*gcx(ji-1,jj  )   &
-                                 - gcp(ji,jj,3)*gcx(ji+1,jj  )   &
-                                 - gcp(ji,jj,4)*gcx(ji  ,jj+1)   )
+                  zgcad = bmask(ji,jj) * ( gcb(ji,jj  ) -                gcx(ji  ,jj  )   &
+                     &                                  - gcp(ji,jj,1) * gcx(ji  ,jj-1)   &
+                     &                                  - gcp(ji,jj,2) * gcx(ji-1,jj  )   &
+                     &                                  - gcp(ji,jj,3) * gcx(ji+1,jj  )   &
+                     &                                  - gcp(ji,jj,4) * gcx(ji  ,jj+1)   )
                   gcr  (ji,jj) = zgcad
                   gcdes(ji,jj) = zgcad
@@ -136,140 +112,74 @@
             END DO
             
-            !,,,,,,,,,,,,,,,,,,,,,,,,synchro ,,,,,,,,,,,,,,,,,,,,,,,
-            
             rnorme = SUM(  gcr(:,:) * gcdmat(:,:) * gcr(:,:)  )
-
-#if defined key_mpp
-            ! Mpp: sum over all the global domain
-            CALL mpp_sum( rnorme )
-#endif
+            IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
             rr = rnorme
 
-        ENDIF
-        !,,,,,,,,,,,,,,,,,,,,,,,,synchro ,,,,,,,,,,,,,,,,,,,,,,,
+         ENDIF
         
+         !                             ! Algorithm
         
-        ! 1.1 Algorithm
-        ! -------------
+         CALL lbc_lnk( gcdes, c_solver_pt, 1. )   ! lateral boundary condition
         
-        ! boundary condition on gcdes (only cyclic bc are required)
-#if defined key_dynspg_fsc
-#   if defined key_mpp
-        !   Mpp: export boundary values to neighbouring processors
-        CALL lbc_lnk( gcdes, 'S', 1. )
-#   else
-        !   mono- or macro-tasking: W-point, >0, 2D array, no slab
-        CALL lbc_lnk( gcdes, 'T', 1. )
-#   endif
-#else
-#   if defined key_mpp
-        !   Mpp: export boundary values to neighbouring processors
-        CALL lbc_lnk( gcdes, 'G', 1. )
-#   else
-        !   mono- or macro-tasking: F-point, >0, 2D array, no slab
-        CALL lbc_lnk( gcdes, 'F', 1. )
-#   endif
-#endif
+         ! ... gccd = matrix . gcdes
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               gccd(ji,jj) = bmask(ji,jj)*( gcdes(ji,jj)   &
+                  &        +gcp(ji,jj,1)*gcdes(ji,jj-1)+gcp(ji,jj,2)*gcdes(ji-1,jj)   &
+                  &        +gcp(ji,jj,4)*gcdes(ji,jj+1)+gcp(ji,jj,3)*gcdes(ji+1,jj)   )
+            END DO
+         END DO
+ 
+         ! alph = (gcr,gcr)/(gcdes,gccd)
+         radd = SUM(  gcdes(:,:) * gcdmat(:,:) * gccd(:,:)  )
+         IF( lk_mpp )   CALL mpp_sum( radd )   ! sum over the global domain
+         alph = rr / radd
+         
+         ! gcx = gcx + alph * gcdes
+         ! gcr = gcr - alph * gccd
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               gcx(ji,jj) = bmask(ji,jj) * ( gcx(ji,jj) + alph * gcdes(ji,jj) )
+               gcr(ji,jj) = bmask(ji,jj) * ( gcr(ji,jj) - alph * gccd (ji,jj) )
+            END DO
+         END DO
         
-        !,,,,,,,,,,,,,,,,,,,,,,,,synchro if macrotasking,,,,,,,,,,,,,,,,,,,,,,,
+         ! rnorme = (gcr,gcr)
+         rnorme = SUM(  gcr(:,:) * gcdmat(:,:) * gcr(:,:)  )
+         IF( lk_mpp )   CALL  mpp_sum( rnorme )   ! sum over the global domain
         
-        ! ... gccd = matrix . gcdes
-        DO jj = 2, jpjm1
-           DO ji = fs_2, fs_jpim1   ! vector opt.
-              gccd(ji,jj) = bmask(ji,jj)*(   &
-                 gcdes(ji,jj)   &
-                +gcp(ji,jj,1)*gcdes(ji,jj-1)+gcp(ji,jj,2)*gcdes(ji-1,jj)   &
-                +gcp(ji,jj,4)*gcdes(ji,jj+1)+gcp(ji,jj,3)*gcdes(ji+1,jj)   &
-                )
-           END DO
-        END DO
+         ! test of convergence
+         IF( rnorme < epsr .OR. jn == nmax ) THEN
+            res = SQRT( rnorme )
+            niter = jn
+            ncut = 999
+         ENDIF
+        
+         ! beta = (rk+1,rk+1)/(rk,rk)
+         beta = rnorme / rr
+         rr   = rnorme
 
-        !,,,,,,,,,,,,,,,,,,,,,,,,synchro if macrotasking,,,,,,,,,,,,,,,,,,,,,,,
+         ! indicator of non-convergence or explosion
+         IF( jn == nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
+         IF( ncut == 999 ) GOTO 999
+
+         ! gcdes = gcr + beta * gcdes
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               gcdes(ji,jj) = bmask(ji,jj)*( gcr(ji,jj) + beta * gcdes(ji,jj) )
+            END DO
+         END DO
         
-        ! alph = (gcr,gcr)/(gcdes,gccd)
-
-        radd = SUM(  gcdes(:,:) * gcdmat(:,:) * gccd(:,:)  )
-
-#if defined key_mpp
-        ! Mpp: sum over all the global domain
-        CALL mpp_sum( radd )
-#endif
-        alph = rr / radd
-        
-        !,,,,,,,,,,,,,,,,,,,,,,,,synchro if macrotasking,,,,,,,,,,,,,,,,,,,,,,,
-        
-        ! gcx = gcx + alph * gcdes
-        ! gcr = gcr - alph * gccd
-        DO jj = 2, jpjm1
-           DO ji = fs_2, fs_jpim1   ! vector opt.
-              gcx(ji,jj) = bmask(ji,jj) * ( gcx(ji,jj) + alph * gcdes(ji,jj) )
-              gcr(ji,jj) = bmask(ji,jj) * ( gcr(ji,jj) - alph * gccd (ji,jj) )
-           END DO
-        END DO
-        
-        !,,,,,,,,,,,,,,,,,,,,,,,,synchro if macrotasking,,,,,,,,,,,,,,,,,,,,,,,
-        
-        ! rnorme = (gcr,gcr)
-
-        rnorme = SUM(  gcr(:,:) * gcdmat(:,:) * gcr(:,:)  )
-
-#if defined key_mpp
-        ! Mpp: sum over all the global domain
-        CALL  mpp_sum( rnorme )
-#endif
-        
-        ! test of convergence
-        IF ( rnorme < epsr .OR. jn == nmax ) THEN
-           res = SQRT( rnorme )
-           niter = jn
-           ncut = 999
-        ENDIF
-        
-        ! beta = (rk+1,rk+1)/(rk,rk)
-        beta = rnorme / rr
-        rr   = rnorme
-
-        !,,,,,,,,,,,,,,,,,,,,,,,,synchro if macrotasking,,,,,,,,,,,,,,,,,,,,,,,
-
-        ! indicator of non-convergence or explosion
-        IF( jn == nmax .OR. sqrt(epsr)/eps > 1.e+20 ) kindic = -2
-        IF( ncut == 999 ) GOTO 999
-
-        ! gcdes = gcr + beta * gcdes
-        DO jj = 2, jpjm1
-           DO ji = fs_2, fs_jpim1   ! vector opt.
-              gcdes(ji,jj) = bmask(ji,jj)*( gcr(ji,jj) + beta * gcdes(ji,jj) )
-           END DO
-        END DO
-        
-        !                                             !================
-     END DO                                           !    End Loop
-     !                                                !================
+         !                                             !================
+      END DO                                           !    End Loop
+      !                                                !================
      
-999  CONTINUE
+999   CONTINUE
      
      
-     !  2. Output in gcx with lateral b.c. applied
-     !  ------------------------------------------
+      ! Output in gcx with lateral b.c. applied
+      ! ---------------------------------------
      
-     ! boundary conditions   !!bug ???
-#if defined key_mpp
-     ! Mpp: export boundary values to neighbouring processors
-# if defined key_dynspg_fsc
-     CALL lbc_lnk( gcx, 'S', 1. )
-# else
-     CALL lbc_lnk( gcx, 'G', 1. )
-# endif
-#else
-     IF ( nperio /= 0 ) THEN
-# if defined key_dynspg_fsc
-        ! mono- or macro-tasking: W-point, >0, 2D array, no slab
-        CALL lbc_lnk( gcx, 'T', 1. )
-# else
-        ! mono- or macro-tasking: F-point, >0, 2D array, no slab
-        CALL lbc_lnk( gcx, 'F', 1. )
-# endif
-     ENDIF
-#endif
+      CALL lbc_lnk( gcx, c_solver_pt, 1. )
      
    END SUBROUTINE sol_pcg
Index: trunk/NEMO/OPA_SRC/SOL/solsor.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solsor.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solsor.F90	(revision 16)
@@ -22,4 +22,5 @@
    !! * Routine accessibility
    PUBLIC sol_sor              ! ???
+
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LODYC-IPSL  (2003)
@@ -28,11 +29,11 @@
 CONTAINS
       
-   SUBROUTINE sol_sor( kt, kindic )
+   SUBROUTINE sol_sor( kindic )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE sol_sor  ***
       !!                 
       !! ** Purpose :   Solve the ellipic equation for the barotropic stream 
-      !!      function system (default option) or the transport divergence 
-      !!      system (key_dynspg_fsc = T) using a successive-over-relaxation
+      !!      function system (lk_dynspg_rl=T) or the transport divergence 
+      !!      system (lk_dynspg_fsc=T) using a successive-over-relaxation
       !!      method.
       !!       In the former case, the barotropic stream function trend has a
@@ -59,5 +60,4 @@
       !!----------------------------------------------------------------------
       !! * Arguments
-      INTEGER, INTENT(  in   ) ::   kt       ! ocean time-step
       INTEGER, INTENT( inout ) ::   kindic   ! solver indicator, < 0 if the conver-
       !                                      ! gence is not reached: the model is
@@ -67,137 +67,46 @@
       !! * Local declarations
       INTEGER  ::   ji, jj, jn               ! dummy loop indices
-      REAL(wp) ::   zgwgt                    ! temporary scalar
       !!----------------------------------------------------------------------
       
-      
-      ! Iterative loop 
-      ! ==============
-      
-      IF( kt == nit000 )  gccd(:,:) = sor * gcp(:,:,2)
+      !                                                       ! ==============
+      DO jn = 1, nmax                                         ! Iterative loop 
+         !                                                    ! ==============
 
-
-      DO jn = 1, nmax
-
-         !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+         CALL lbc_lnk( gcx, c_solver_pt, 1. )   ! applied the lateral boubary conditions
          
-         ! boundary conditions (at each sor iteration) only cyclic b. c. are required
-#if defined key_dynspg_fsc
-# if defined key_mpp
-            ! Mpp: export boundary values to neighbouring processors
-            CALL lbc_lnk( gcx, 'S', 1. )   ! S=T with special staff ???
-# else
-            CALL lbc_lnk( gcx, 'T', 1. )
-# endif
-#else
-# if defined key_mpp
-            ! Mpp: export boundary values to neighbouring processors
-            CALL lbc_lnk( gcx, 'G', 1. )   ! G= F with special staff ???
-# else
-            CALL lbc_lnk( gcx, 'F', 1. )
-# endif
-#endif
-         
-         !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-         
-         ! 1. Residus
-         ! ----------
- 
+         ! Residus
+         ! -------
          DO jj = 2, jpjm1
             DO ji = 2, jpim1
-               gcr(ji,jj) =  gcb(ji,jj  ) -             gcx(ji  ,jj  )   &
-                                          -gcp(ji,jj,1)*gcx(ji  ,jj-1)   &
-                                          -gcp(ji,jj,2)*gcx(ji-1,jj  )   &
-                                          -gcp(ji,jj,3)*gcx(ji+1,jj  )   &
-                                          -gcp(ji,jj,4)*gcx(ji  ,jj+1)
+               gcr(ji,jj) =  gcb(ji,jj  ) -                gcx(ji  ,jj  )   &
+                                          - gcp(ji,jj,1) * gcx(ji  ,jj-1)   &
+                                          - gcp(ji,jj,2) * gcx(ji-1,jj  )   &
+                                          - gcp(ji,jj,3) * gcx(ji+1,jj  )   &
+                                          - gcp(ji,jj,4) * gcx(ji  ,jj+1)
             END DO
          END DO
+         CALL lbc_lnk( gcr, c_solver_pt, 1. )   ! applied the lateral boubary conditions
 
-         !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-         
-         ! 1.1 Boundary conditions (at each sor iteration) only cyclic b. c. are required
-#if defined key_dynspg_fsc
-#   if defined key_mpp
-            ! Mpp: export boundary values to neighbouring processors
-            CALL lbc_lnk( gcr, 'S', 1. )
-#   else
-            ! mono- or macro-tasking: W-point, >0, 2D array, no slab
-            CALL lbc_lnk( gcr, 'T', 1. )
-#   endif
-#else
-#   if defined key_mpp
-            ! Mpp: export boundary values to neighbouring processors
-            CALL lbc_lnk( gcr, 'G', 1. )
-#   else
-            ! mono- or macro-tasking: W-point, >0, 2D array, no slab
-            CALL lbc_lnk( gcr, 'F', 1. )
-#   endif
-#endif
-
-         ! 1.2 Successive over relaxation
-         
+         ! Successive over relaxation
          DO jj = 2, jpj
             DO ji = 1, jpi
-               gcr(ji,jj) = gcr(ji,jj) - sor*gcp(ji,jj,1)*gcr(ji,jj-1)
+               gcr(ji,jj) = gcr(ji,jj) - sor * gcp(ji,jj,1) * gcr(ji,jj-1)
             END DO
             DO ji = 2, jpi
-               gcr(ji,jj) = gcr(ji,jj) - sor*gcp(ji,jj,2)*gcr(ji-1,jj)
+               gcr(ji,jj) = gcr(ji,jj) - sor * gcp(ji,jj,2) * gcr(ji-1,jj)
             END DO
          END DO
          
-         !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-         
          ! gcx guess
-         
          DO jj = 2, jpjm1
             DO ji = 1, jpi
-               gcx(ji,jj)  = (gcx(ji,jj)+sor*gcr(ji,jj))*bmask(ji,jj)
+               gcx(ji,jj)  = ( gcx(ji,jj) + sor * gcr(ji,jj) ) * bmask(ji,jj)
             END DO
          END DO
-         
-         !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-         
-         ! boundary conditions (at each sor iteration) only cyclic b. c. are required
-#if defined key_dynspg_fsc
-#   if defined key_mpp
-         ! Mpp: export boundary values to neighbouring processors
-         CALL lbc_lnk( gcx, 'S', 1. )
-#   else
-         ! mono- or macro-tasking: W-point, >0, 2D array, no slab
-         CALL lbc_lnk( gcx, 'T', 1. )
-#   endif
-#else
-#   if defined key_mpp
-         ! Mpp: export boundary values to neighbouring processors
-         CALL lbc_lnk( gcx, 'G', 1. )
-#   else
-         ! mono- or macro-tasking: W-point, >0, 2D array, no slab
-         CALL lbc_lnk( gcx, 'F', 1. )
-#   endif
-#endif
-         
-         ! maximal residu (old exit test on the maximum value of residus)
-         ! 
-         ! imax = isamax( jpi*jpj, gcr, 1 )
-         
-         ! avoid an out of bound in no bounds compilation
-         
-         ! iimax1 = mod( imax, jpi )
-         ! ijmax1 = int( float(imax) / float(jpi)) + 1
-         ! resmax = abs( gcr(iimax1,ijmax1) )
+         CALL lbc_lnk( gcx, c_solver_pt, 1. )
          
          ! relative precision
-         
-         rnorme = 0.
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zgwgt = gcdmat(ji,jj) * gcr(ji,jj)
-               rnorme= rnorme + gcr(ji,jj)*zgwgt
-            END DO
-         END DO
-         
-#if defined key_mpp
-         ! mpp sum over all the global domain
-         CALL  mpp_sum( rnorme )
-#endif
+         rnorme = SUM( gcr(:,:) * gcdmat(:,:) * gcr(:,:) )
+         IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
          
          ! test of convergence
@@ -216,45 +125,19 @@
          !****
          
-         !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-         
          ! indicator of non-convergence or explosion
-         
          IF( jn == nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
          IF( ncut == 999 ) GOTO 999
          
-         
-         ! END of iterative loop
-         ! =====================
-         
-      END DO
-      
+         !                                                 ! =====================
+      END DO                                               ! END of iterative loop
+      !                                                    ! =====================
       
 999   CONTINUE
       
       
-      !  2. Output in gcx
-      !  -----------------
+      !  Output in gcx
+      !  -------------
       
-      ! boundary conditions (est-ce necessaire? je ne crois pas!!!!)
-      
-#if defined key_dynspg_fsc
-# if defined key_mpp
-      ! Mpp: export boundary values to neighbouring processors
-      CALL lbc_lnk( gcx, 'S', 1. )
-# else
-      IF( nperio /= 0 ) THEN
-         CALL lbc_lnk( gcx, 'T', 1. )
-      ENDIF
-# endif
-#else
-# if defined key_mpp
-      ! Mpp: export boundary values to neighbouring processors
-      CALL lbc_lnk( gcx, 'G', 1. )
-# else
-      IF( nperio /= 0 ) THEN
-         CALL lbc_lnk( gcx, 'F', 1. )
-      ENDIF
-# endif
-#endif
+      CALL lbc_lnk( gcx, c_solver_pt, 1. )    ! boundary conditions (est-ce necessaire? je ne crois pas!!!!)
       
    END SUBROUTINE sol_sor
Index: trunk/NEMO/OPA_SRC/SOL/solver.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solver.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solver.F90	(revision 16)
@@ -18,4 +18,7 @@
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE lib_mpp
+   USE dynspg_rl       
+   USE dynspg_fsc      
 
    IMPLICIT NONE
@@ -34,10 +37,10 @@
       !!       * default option: barotropic stream function system
       !!         and islands initialization (if l_isl=T)
-      !!       * key_dynspg_fsc = T : transport divergence system. No specific
+      !!       * lk_dynspg_fsc = T : transport divergence system. No specific
       !!         treatment of islands.
       !!      
       !! ** Method :
       !!       - Compute the local depth of the water column at u- and v-point
-      !!      (key_dynspg_fsc = T) or its inverse (key_dynspg_rl = T).
+      !!      (lk_dynspg_fsc = T) or its inverse (lk_dynspg_rl = T).
       !!      The local depth of the water column is computed by summing 
       !!      the vertical scale factors. For its inverse, the thickness of
@@ -56,7 +59,9 @@
       !!
       !! ** Action : - hur, hvr : masked inverse of the local depth at
-      !!                                u- and v-point. (key_dynspg_rl = T)
+      !!                                u- and v-point. (lk_dynspg_rl = T)
       !!             - hu, hv   : masked local depth at u- and v- points
-      !!                                (key_dynspg_fsc = T)
+      !!                                (lk_dynspg_fsc = T)
+      !!             - c_solver_pt : nature of the gridpoint at which the
+      !!                                solver is applied
       !! References :
       !!      Jensen, 1986: adv. phys. oceanogr. num. mod.,ed. o brien,87-110.
@@ -115,5 +120,5 @@
       ENDIF
 
-#if defined key_dynspg_fsc 
+      IF( lk_dynspg_fsc ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '          *** free surface formulation'
@@ -123,14 +128,17 @@
             nstop = nstop + 1
          ENDIF
-#endif
-#if defined key_dynspg_rl
+      ELSEIF( lk_dynspg_rl ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '          *** Rigid lid formulation'
-#endif
-#if defined key_dynspg_fsc && defined key_dynspg_rl
+      ELSE
+         IF(lwp) WRITE(numout,cform_err)
+         IF(lwp) WRITE(numout,*) '          Chose at least one surface pressure gradient calculation: free surface or rigid-lid'
+         nstop = nstop + 1
+      ENDIF
+      IF( lk_dynspg_fsc .AND. lk_dynspg_rl ) THEN
          IF(lwp) WRITE(numout,cform_err)
          IF(lwp) WRITE(numout,*) '          Chose between free surface or rigid-lid, not both'
          nstop = nstop + 1
-#endif
+      ENDIF
 
       SELECT CASE ( nsolv )
@@ -144,13 +152,13 @@
       CASE ( 3 )                ! FETI solver
          IF(lwp) WRITE(numout,*) '          use the FETI solver'
-#if ! defined key_mpp
-         IF(lwp) WRITE(numout,*) ' The FETI algorithm is used only with the key_mpp option'
-         nstop = nstop + 1
-#else
-         IF( jpnij == 1 ) THEN
-            IF(lwp) WRITE(numout,*) ' The FETI algorithm needs more than one processor'
+         IF( .NOT.lk_mpp ) THEN
+            IF(lwp) WRITE(numout,*) ' The FETI algorithm is used only with the key_mpp_... option'
             nstop = nstop + 1
-         ENDIF
-#endif
+         ELSE
+            IF( jpnij == 1 ) THEN
+               IF(lwp) WRITE(numout,*) ' The FETI algorithm needs more than one processor'
+               nstop = nstop + 1
+            ENDIF
+         ENDIF
          
       CASE DEFAULT
@@ -161,4 +169,21 @@
       END SELECT
 
+      ! Grid-point at which the solver is applied
+      ! -----------------------------------------
+
+      IF( lk_dynspg_rl ) THEN       ! rigid-lid
+         IF( lk_mpp ) THEN
+            c_solver_pt = 'G'   ! G= F with special staff ??? which one?
+         ELSE
+            c_solver_pt = 'F'
+         ENDIF
+      ELSE                          ! free surface T-point
+         IF( lk_mpp ) THEN
+            c_solver_pt = 'S'   ! S=T with special staff ??? which one?
+         ELSE
+            c_solver_pt = 'T'
+         ENDIF
+      ENDIF
+
 
       ! Construction of the elliptic system matrix
Index: trunk/NEMO/OPA_SRC/TRD/trddyn.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trddyn.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/TRD/trddyn.F90	(revision 16)
@@ -34,5 +34,5 @@
 
    !! * Shared module vaiables
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .TRUE.   ! momentum trend flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
 
    !! * Substitutions
@@ -231,6 +231,6 @@
             DO ji = 1, jpi
                zhke(10) = zhke(10)   &
-               &   + ub(ji,jj,1) * tautrd(ji,jj,1) * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,1)   &
-               &   + vb(ji,jj,1) * tautrd(ji,jj,2) * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,1)
+                  &     + ub(ji,jj,1) * tautrd(ji,jj,1) * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,1)   &
+                  &     + vb(ji,jj,1) * tautrd(ji,jj,2) * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,1)
             END DO
          END DO
@@ -240,16 +240,16 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zpeke    = zpeke + zkepe(ji,jj,jk) * g * fsdept(ji,jj,jk)   &
-                  &                        * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-               END DO
-            END DO
-         END DO
-         
-# if defined key_mpp
-         CALL mpp_sum( zpeke )
-         CALL mpp_sum( zumo , 11 )
-         CALL mpp_sum( zvmo , 11 )
-         CALL mpp_sum( zhke , 10 )
-# endif
+                  zpeke    = zpeke + zkepe(ji,jj,jk) * grav * fsdept(ji,jj,jk)   &
+                     &                     * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         
+         IF( lk_mpp ) THEN
+            CALL mpp_sum( zpeke )
+            CALL mpp_sum( zumo , 11 )
+            CALL mpp_sum( zvmo , 11 )
+            CALL mpp_sum( zhke , 10 )
+         ENDIF
 
 
@@ -423,9 +423,7 @@
          END DO
       END DO
-# if defined key_mpp
-      CALL mpp_sum( tvols )
-      CALL mpp_sum( tvolu )
-      CALL mpp_sum( tvolv )
-# endif
+      IF( lk_mpp )   CALL mpp_sum( tvols )   ! sums over the global domain
+      IF( lk_mpp )   CALL mpp_sum( tvolu )
+      IF( lk_mpp )   CALL mpp_sum( tvolv )
 
       IF(lwp) THEN
@@ -446,8 +444,8 @@
    !!   Default option :                      NO mementum trend diagnostics
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .FALSE.   ! momentum trend flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
 CONTAINS
    SUBROUTINE trd_dyn( kt )        ! Empty routine
-      WRITE(*,*) kt
+      WRITE(*,*) 'trd_dyn: You should not have seen this print! error?', kt
    END SUBROUTINE trd_dyn
    SUBROUTINE trd_dyn_init         ! Empty routine
Index: trunk/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 16)
@@ -37,5 +37,5 @@
 
    !! * Shared module variables
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .TRUE.   ! momentum trend flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .TRUE.    !: momentum trend flag
 
    !! * Module variables
@@ -609,8 +609,8 @@
    !!   Default option :                                       Empty module
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .FALSE.   ! momentum trend flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .FALSE.   !: momentum trend flag
 CONTAINS
    SUBROUTINE trd_mld( kt )        ! Empty routine
-      WRITE(*,*) kt
+      WRITE(*,*) 'trd_mld: You should not have seen this print! error?', kt
    END SUBROUTINE trd_mld
 #endif
Index: trunk/NEMO/OPA_SRC/TRD/trdtra.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdtra.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/TRD/trdtra.F90	(revision 16)
@@ -33,5 +33,5 @@
 
    !! * Shared module variables
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .TRUE.   ! momentum trend flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .TRUE.    !: momentum trend flag
 
    !! * Substitutions
@@ -95,7 +95,6 @@
             END DO
          END DO
-#if defined key_mpp
-         CALL mpp_sum( tvolt )
-#endif
+         IF( lk_mpp )   CALL mpp_sum( tvolt )   ! sum over the global domain
+
          IF(lwp) THEN
             WRITE(numout,*)
@@ -208,10 +207,10 @@
          END DO
          
-#if defined key_mpp
-         CALL mpp_sum( ztmo, 10 )
-         CALL mpp_sum( zsmo, 10 )
-         CALL mpp_sum( zt2 , 10 )
-         CALL mpp_sum( zs2 , 10 )
-#endif
+         IF( lk_mpp ) THEN
+            CALL mpp_sum( ztmo, 10 )   ! sums over the global domain
+            CALL mpp_sum( zsmo, 10 )
+            CALL mpp_sum( zt2 , 10 )
+            CALL mpp_sum( zs2 , 10 )
+         ENDIF
          
          ! 4. Print
@@ -358,10 +357,7 @@
          END DO
       END DO
-#if defined key_mpp
-      CALL mpp_sum( tvolt )
-#endif
-      IF(lwp) THEN
-         WRITE(numout,*) '          total ocean volume at T-point   tvolt = ',tvolt
-      ENDIF
+      IF( lk_mpp )   CALL mpp_sum( tvolt )   ! sum over the global domain
+
+      IF(lwp) WRITE(numout,*) '          total ocean volume at T-point   tvolt = ',tvolt
 
    END SUBROUTINE trd_tra_init
@@ -371,8 +367,8 @@
    !!   Default case :                                         Empty module
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .FALSE.   ! momentum trend flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .FALSE.   !: momentum trend flag
 CONTAINS
    SUBROUTINE trd_tra( kt )        ! Empty routine
-      WRITE(*,*) kt
+      WRITE(*,*) 'trd_tra: You should not have seen this print! error?', kt
    END SUBROUTINE trd_tra
    SUBROUTINE trd_tra_init         ! Empty routine
Index: trunk/NEMO/OPA_SRC/TRD/trdtra_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdtra_oce.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/TRD/trdtra_oce.F90	(revision 16)
@@ -12,5 +12,5 @@
    PUBLIC
 
-   INTEGER  ::      & !!! namdia :  diagnostics on dynamics and/or tracer trends
+   INTEGER  ::      & !!: namdia :  diagnostics on dynamics and/or tracer trends
       ntrd  = 10 ,  &  !: time step frequency dynamics and tracers trends
       nctls =  0       !: control surface type for trends vertical integration
@@ -25,5 +25,5 @@
    !! Trends diagnostics parameters
    !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::            &
+   INTEGER, PARAMETER ::            &  !:
 # if defined key_traldf_eiv
       jptrdh = 4,   &  !: number of 3D horiz trends arrays
@@ -38,7 +38,7 @@
    !! Trends diagnostics variables
    !!---------------------------------------------------------------------
-   REAL(wp) ::   &
-      tvolt         ! volume of the whole ocean computed at t-points
-   REAL(wp), DIMENSION(jpi,jpj,jpk,7) ::   &
+   REAL(wp) ::   &  !:
+      tvolt         !: volume of the whole ocean computed at t-points
+   REAL(wp), DIMENSION(jpi,jpj,jpk,7) ::   &  !:
       ttrd             !: trends of the temperature tracer equations
       !                !  ttrd(,,,1) : horizontal advection
@@ -49,13 +49,13 @@
       !                !  ttrd(,,,6) : damping OR vertical EIV
       !                !  ttrd(,,,7) : penetrative solar radiation (T only)
-   REAL(wp), DIMENSION(jpi,jpj,jpk,6) ::   &
+   REAL(wp), DIMENSION(jpi,jpj,jpk,6) ::   &  !:
       strd             !: trends of the salinity tracer equations
       !                !  same as ttrd()
-   REAL(wp), DIMENSION(jpi,jpj,jpk,jptrdh) ::   &
+   REAL(wp), DIMENSION(jpi,jpj,jpk,jptrdh) ::   &  !:
       ttrdh, strdh     !: ttrdh(,,,1) : zonal advection
       !                !  ttrdh(,,,2) : meridional advection
       !                !  ttrdh(,,,3) : zonal EIV
       !                !  ttrdh(,,,4) : meridional EIV
-   REAL(wp), DIMENSION(jpi,jpj,2) ::   &
+   REAL(wp), DIMENSION(jpi,jpj,2) ::   &  !:
       flxtrd,       &  !: tracer forcing trends
       bbltrd           !: tracer bottom boundary layer trends
